// Exemple du DP Adaptateur

public class ExempleCh04_13_Introduction
{
  public static void main(String[] args)
  {
  }
}

// ===== La ligne d'une facture
// ==================================================

class LigneFactureImp
{
  private String reference;
  private String designation;
  private int    quantite;  // nb, duree, longueur, ....
  private String unite;  // defaut, heure, minute, m, km, ....
  private double prixUnitaireHT;
  private double montantHT;
  private double tva;
  private double montantTVA;
  private double montantTTC;

  public LigneFactureImp(String reference,String designation,double prixUnitaireHT,double tva,int quantite,String unite){
    this.reference = reference;
    this.designation = designation;
    this.quantite = quantite;
    this.unite = unite;
    this.prixUnitaireHT = prixUnitaireHT;
    this.montantHT = this.quantite*this.prixUnitaireHT;
    this.tva = tva;
    this.montantTVA = this.montantHT*this.tva/100;
    this.montantTTC = this.montantHT+this.montantTVA;
  }

  public String toString(){
    return String.format("%-15s %-50s %2d %6s %7.2f %7.2f %7.2f %7.2f %7.2f",
                         reference,designation,quantite,unite,prixUnitaireHT,montantHT,tva,montantTVA,montantTTC);
  }
}

// ===== Un produit manufactur
// ==================================================
class Produit
{
  private String reference;
  private String nom;
  private String marque;
  private double prixHT;  
  private double tauxTva;

  public Produit(String reference,String nom,String marque,double prixHT,double tauxTva)
  {
    this.reference = reference;
    this.nom = nom;
    this.marque = marque;
    this.prixHT = prixHT;
    this.tauxTva = tauxTva;
  }

  public String getReference(){return this.reference;}
  public String getNom(){return this.nom;}
  public String getMarque(){return this.marque;}
  public double getPrixHT(){return this.prixHT;}
  public double getTauxTva(){return this.tauxTva;}
}


// ===== Une prestation de service  facturer
// ==================================================
  class Prestation
  {
    private String denomination;
    private double prixHeure;  
    public static final double tauxTva = 18.0;

    public Prestation(String denomination,double prixHeure){
      this.denomination = denomination;
      this.prixHeure = prixHeure;
    }

    public String getDenomination(){return denomination;}
    public double getPrixHeure(){return prixHeure;}
  }


